/*
  EDMA IDFWizard GNOMIZED Version 0.1.0
  Copyright (C) 1998-1999 David Martnez Oliveira
  
  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with this program; see the file COPYING.  If not, write to
  the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
  Boston, MA 02111-1307, USA.
  
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <signal.h>
#include <time.h>
#include <unistd.h>
#include <gnome.h>
#include <edma.h>
/*
#include <edma/portable.h>
#include <edma/dlink.h>
#include <edma/dynlink.h>
*/
#include "inhform.h"


void class_click( GtkWidget *clist, gint row, gint column,
                     GdkEventButton *event, gpointer data)
{
  ((InheritanceWidgets*)data)->actual=row;
  printf ("\nselected %d superclass to add",row);
}

void class1_click( GtkWidget *clist, gint row, gint column,
                     GdkEventButton *event, gpointer data)
{
  ((InheritanceWidgets*)data)->actual1=row;
  printf ("\nselected %d superclass to del",row);
}

void add_click( GtkWidget *bot, gpointer data)
{
  EPChar   text;
  EUint32  n,i;
  EChar    aux[80],name[80],type[80],access[80],array[80];
  gchar    *prop_data[]={name,type,access,array};
  InheritanceWidgets *gw;


  gw=(InheritanceWidgets*)data;
  gtk_clist_get_text(GTK_CLIST(gw->class_list), gw->actual, 0, &text);
  g_print ("Selected (%d) %s",gw->actual,text);
  prop_data[0]=text;
  gw->SCList[gw->n]=gw->actual;
  gw->n++;
  gtk_clist_append(GTK_CLIST(gw->SClass_list),prop_data);
  

}

void del_click( GtkWidget *bot, gpointer data)
{
  EPChar   text;
  EUint32  n,i;
  InheritanceWidgets *gw;


  gw=(InheritanceWidgets*)data;
  gtk_clist_remove(GTK_CLIST(gw->SClass_list), gw->actual1);
  g_print ("Selected (%d) ",gw->actual1);
  gw->SCList[gw->actual1]=-1;
  for (i=gw->actual1; i< gw->n;i++)
    {
      gw->SCList[i]=gw->SCList[i+1];
    }
  gw->SCList[i]=-1;
  gw->n--;


}

ESint32 InitInhForm (InheritanceWidgets *gw)
{
  EUint32   n,i;
  EChar     name[80];

  gw->n=0;
  for (i=0;i<MAX_SC;i++)
    gw->SCList[i]=-1;
  gw->build_form=BuildInhForm;
  // Init lists
  gw->classes=NULL;
  /*
  n=pGetRegClases();
  for (i=0;i<n;i++)
    {
      pGetClaseName(i,name);
      printf ("\n%s",name);
      gw->classes=g_list_append (gw->classes,name);
    }
  //  gw->types=g_list_append (gw->types,"EUINT32");
  */
  gw->Sclasses=NULL;

}

ESint32 BuildInhForm (InheritanceWidgets *gw,GtkWidget *note)
{   
  GtkWidget *label,*aux,*swindow,*box;
  GList     *p;
  EUint32   i,n;
  EChar     name[80];
  gchar     *text[]={name,NULL};

  // General Info Page
  gw->table=gtk_table_new (1,5,TRUE);

  swindow=gtk_scrolled_window_new(NULL,NULL);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (swindow),
				  GTK_POLICY_AUTOMATIC, GTK_POLICY_ALWAYS);

  gw->class_list=gtk_clist_new(1);
  gtk_container_add(GTK_CONTAINER(swindow),gw->class_list);
  gtk_clist_set_column_title(GTK_CLIST(gw->class_list),0,"ClassName");
  //   gtk_clist_set_column_width(GTK_CLIST(prop_clist),0,80);
  gtk_clist_column_titles_show(GTK_CLIST(gw->class_list));
  gtk_widget_show(swindow);
  gtk_widget_show(gw->class_list);
  // Intro data
  n=GetRegClases();
  for (i=0;i<n;i++)
    {
      GetClaseName(i,name);
      gtk_clist_append(GTK_CLIST(gw->class_list),text);
      //gw->classes=g_list_append (gw->classes,name);
    }

  //  gtk_table_attach_defaults (GTK_TABLE(gw->table), gw->class_list, 0, 1, 0, 1);
  gtk_table_attach_defaults (GTK_TABLE(gw->table), swindow, 0, 2, 0, 1);
  swindow=gtk_scrolled_window_new(NULL,NULL);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (swindow),
				  GTK_POLICY_AUTOMATIC, GTK_POLICY_ALWAYS);


  gtk_signal_connect (GTK_OBJECT (gw->class_list), "select_row",
		      GTK_SIGNAL_FUNC (class_click), gw);

  gw->SClass_list=gtk_clist_new(1);
  gtk_container_add(GTK_CONTAINER(swindow),gw->SClass_list);
  gtk_clist_set_column_title(GTK_CLIST(gw->SClass_list),0,"ClassName");
  //   gtk_clist_set_column_width(GTK_CLIST(prop_clist),0,80);
  gtk_clist_column_titles_show(GTK_CLIST(gw->SClass_list));
  gtk_widget_show(swindow);
  gtk_widget_show(gw->SClass_list);

  gtk_signal_connect (GTK_OBJECT (gw->SClass_list), "select_row",
		      GTK_SIGNAL_FUNC (class1_click), gw);

  gtk_table_attach_defaults (GTK_TABLE(gw->table), swindow, 3, 5, 0, 1);

  box=gtk_vbox_new(FALSE,FALSE);
  gw->Add=gtk_button_new_with_label(">>");
  gw->Del=gtk_button_new_with_label("<<");
  gtk_box_pack_start (GTK_BOX(box),gw->Add,FALSE,FALSE,2);
  gtk_box_pack_start (GTK_BOX(box),gw->Del,FALSE,FALSE,2);

  gtk_signal_connect (GTK_OBJECT (gw->Add), "clicked",
		      GTK_SIGNAL_FUNC (add_click), (gpointer) gw);
  gtk_signal_connect (GTK_OBJECT (gw->Del), "clicked",
		      GTK_SIGNAL_FUNC (del_click), (gpointer) gw);

  gtk_table_attach_defaults (GTK_TABLE(gw->table), box, 2, 3, 0, 1);  
  gtk_widget_show(box);
  gtk_widget_show(gw->Add);
  gtk_widget_show(gw->Del);
  gtk_widget_show(gw->table);
  label=gtk_label_new("Inheritance");
  gtk_notebook_append_page (GTK_NOTEBOOK (note), gw->table, label);
  
  return 0;
}



ESint32 InhGetNSC (InheritanceWidgets *gw)
{
  return gw->n;
}
ESint32 InhGetSC (InheritanceWidgets *gw,EUint32 i,EPChar r)
{
  EChar name[80];

  GetClaseName(gw->SCList[i],name);
  strcpy (r,name);
 
  return strlen(r);
}

void InhInit(InheritanceWidgets *gw)
{
  gw->n=0;
  gw->actual=0;
  gw->actual1=0;

 gtk_clist_clear(GTK_CLIST(gw->SClass_list));

}
void InhSet( InheritanceWidgets *gw, EPChar Name)
{
  EPChar   text;
  EUint32  n,i;
  EChar    aux[80],name[80],type[80],access[80],array[80];
  gchar    *prop_data[]={name,type,access,array};
  //  InheritanceWidgets *gw;


  //  gw=(InheritanceWidgets*)data;
  //  gtk_clist_get_text(GTK_CLIST(gw->class_list), gw->actual, 0, &text);
 // Locate index
  n=GetRegClases();
  for (i=0;i<n;i++)
    {
      GetClaseName(i,name);
      if (strcmp(Name,name)==0)
	break;
    }
  if (i==n)
    {
      g_print ("Class %s not exists",Name);
      return;
    }
  gw->actual=i;
  gtk_clist_get_text(GTK_CLIST(gw->class_list), gw->actual, 0, &text);
  g_print ("Selected (%d) %s",gw->actual,text);
  text=Name;
  prop_data[0]=text;

  gw->SCList[gw->n]=gw->actual;
  gw->n++;
  gtk_clist_append(GTK_CLIST(gw->SClass_list),prop_data);
  

}

