/*
  EDMA IDFWizard GNOMIZED Version 0.1.0
  Copyright (C) 1998-1999 David Martnez Oliveira
  
  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with this program; see the file COPYING.  If not, write to
  the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
  Boston, MA 02111-1307, USA.
  
 */
#include <gnome.h>
#include <edma.h>
/*
#include <edma/portable.h>
#include <edma/dlink.h>
#include <edma/dynlink.h>
*/
#ifndef INTERFACE_H
#define INTERFACE_H

// Structs for data entry forms

typedef struct
{
  GtkWidget       *table;
  GtkWidget       *ClassName;
  GtkWidget       *ModuleName;
  GtkWidget       *TargetLanguage;
  GtkWidget       *OS;
  GtkWidget       *Machine;
  GtkWidget       *SIUProxy;
  GtkWidget       *IsSIUProxy;
  GtkWidget       *IDFParser;
  GtkWidget       *IsIDFParser;
  GtkWidget       *IsEMI;
  GList           *languages=NULL;
  GList           *sos=NULL;
  GList           *proxies=NULL;
  GList           *parsers=NULL;
  // Functions
  ESint32         (*build_form)(GTKWidget *);
} GeneralWidgets;

typedef struct
{
  GtkWidget       *table;
  GtkWidget       *the_list;
  GtkWidget       *Type;
  GtkWidget       *Name;
  GtkWidget       *Access;
  GtkWidget       *Array;
  GtkWidget       *Add;
  GtkWidget       *Del;
  GtkWidget       *Set;
  GList           *types=NULL;
  GList           *access_mode=NULL;
  // Functions
  ESint32         (*build_form)(GTKWidget *);
} PropertyWidgets;

typedef struct
{
  GtkWidget       *table;
  GtkWidget       *the_list;
  GtkWidget       *Name;
  GtkWidget       *Signature;
  GtkWidget       *Virtual;
  GtkWidget       *AddConstructor;
  GtkWidget       *AddDestructor;
  GtkWidget       *Add;
  GtkWidget       *Del;
  GtkWidget       *Set;
  // Functions
  ESint32         (*build_form)(GTKWidget *);
} MethodWidgets;

typedef struct
{
  GtkWidget       *table;
  GtkWidget       *class_list;
  GtkWidget       *SClass_list;
  GtkWidget       *Add;
  GtkWidget       *Del;
  GList           *classes=NULL;
  GList           *Sclasses=NULL;
  // Functions
  ESint32         (*build_form)(GTKWidget *);
} InhWidgets;

typedef struct
{
  GtkWidget       *table;
  GtkWidget       *Author;
  GtkWidget       *Date;
  GtkWidget       *TargetDir;
  GtkWidget       *BrowseTargetDir;
  // Functions
  ESint32         (*build_form)(GTKWidget *);
} PrefWidgets;

#endif
