/*
  EDMA IDFWizard GNOMIZED Version 0.1.0
  Copyright (C) 1998-1999 David Martnez Oliveira
  
  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with this program; see the file COPYING.  If not, write to
  the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
  Boston, MA 02111-1307, USA.
  
 */

#ifndef METHOD_FORM_H
#define METHOD_FORM_H

#include <gnome.h>
#include <edma.h>
/*
#include <edma/portable.h>
#include <edma/dlink.h>
#include <edma/dynlink.h>
*/
//#include "interface.h"

#define MAX_MET 200
typedef struct
{
  EChar   Name[80];
  EChar   Sig[80];
  ESint32   Virtual;
  ESint32   Static;
  ESint32   Abstract;
} MET_INFO;

typedef struct met_widgets
{
  GtkWidget       *table;
  GtkWidget       *the_list;
  GtkWidget       *Name;
  GtkWidget       *Signature;
  GtkWidget       *Virtual;
  GtkWidget       *Static; 
  GtkWidget       *Abstract;
  GtkWidget       *AddConstructor;
  GtkWidget       *AddDestructor;
  GtkWidget       *Add;
  GtkWidget       *Del;
  GtkWidget       *Set;
  //Data
  ESint32         actual;
  ESint32         n;
  MET_INFO        met[MAX_MET];
  // Functions
  ESint32         (*build_form)(struct met_widgets *,GtkWidget *);
} MethodWidgets;

ESint32 InitMetForm (MethodWidgets *gw);
ESint32 BuildMetForm (MethodWidgets *gw,GtkWidget *note);

ESint32 MetGetNM (MethodWidgets *gw);
ESint32 MetGetName (MethodWidgets *gw,ESint32 i,EPChar r);
ESint32 MetGetSignature (MethodWidgets *gw,ESint32 i,EPChar r);
ESint32 MetGetVirtual (MethodWidgets *gw,ESint32 i);
ESint32 MetGetStatic (MethodWidgets *gw,ESint32 i);
ESint32 MetGetAbstract (MethodWidgets *gw,ESint32 i);

void MetInit(MethodWidgets *gw);
void MetSet(MethodWidgets *gw,EPChar,EPChar,EUint32,EUint32,EUint32);
#endif



