/*
  EDMA IDFWizard GNOMIZED Version 0.1.0
  Copyright (C) 1998-1999 David Martnez Oliveira
  
  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  You should have received a copy of the GNU General Public License
  along with this program; see the file COPYING.  If not, write to
  the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
  Boston, MA 02111-1307, USA.
  
 */

#ifndef PROPERTIES_FORM_H
#define PROPERTIES_FORM_H

#include <gnome.h>
#include <edma.h>
/*
#include <edma/portable.h>
#include <edma/dlink.h>
#include <edma/dynlink.h>
*/
//#include "interface.h"

#define MAX_PROPS 200

typedef struct
{
  EChar      Name[80];
  ESint32    Type;
  ESint32    Access;
  ESint32    Array;
  
} PROP_INFO;

typedef struct property_widgets
{
  GtkWidget       *table;
  GtkWidget       *the_list;
  GtkWidget       *Type;
  GtkWidget       *Name;
  GtkWidget       *Access;
  GtkWidget       *Array;
  GtkWidget       *Add;
  GtkWidget       *Del;
  GtkWidget       *Set;
  GList           *types;
  GList           *access_mode;
  // Data
  ESint32         actual;
  ESint32         n;
  PROP_INFO       props[MAX_PROPS];
  // Functions
  ESint32         (*build_form)(struct property_widgets *,GtkWidget *);
} PropertyWidgets;

ESint32 InitPropForm (PropertyWidgets *gw);
ESint32 BuildPropForm (PropertyWidgets *gw,GtkWidget *note);

ESint32 PropGetNP (PropertyWidgets *gw);
ESint32 PropGetName (PropertyWidgets *gw,ESint32 i,EPChar r);
ESint32 PropGetAccess (PropertyWidgets *gw,ESint32 i,EPChar r);
ESint32 PropGetType (PropertyWidgets *gw,ESint32 i,EPChar r);
ESint32 PropGetArray (PropertyWidgets *gw,ESint32 i);

void PropSet( PropertyWidgets *gw, EPChar Name,EPChar Type,EPChar Access,EUint32 n);
void PropInit (PropertyWidgets *);
#endif



